%define oldname crimson
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# build with native support:
%define gcj_support 0


Name: jakarta-crimson
Epoch: 0
Version: 1.1.3
Release: alt2_17jpp1.7
Summary: Java XML parser

Group: Development/Java
License: Apache Software License
URL: http://xml.apache.org/%{oldname}
Source0: http://xml.apache.org/dist/%{oldname}/%{oldname}-%{version}-src.tar.gz
Patch0: %{oldname}-noapis.patch
Provides: jaxp_parser_impl
%if ! %{gcj_support}
BuildArch: noarch
%endif

BuildRequires: ant
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: xml-commons-apis
Requires: xml-commons-apis
Requires(post): alternatives >= 0:0.2.0-alt0.12
Requires(preun): alternatives >= 0:0.2.0-alt0.12
Requires: jpackage-utils >= 0:1.6
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Crimson is a Java XML parser which supports XML 1.0 via the following
APIs:
- Java API for XML Processing (JAXP) 1.1 minus the javax.xml.transform
package. JAXP is a pluggable API that allows applications to access XML
documents in a parser-independent manner. It endorses the industry
standard SAX and DOM APIs and also adds a few classes under the
javax.xml.parsers package to implement pluggability and utility methods
Note: the javax.xml.transform package hierarchy of JAXP is not
implemented by Crimson. One implementation of javax.xml.transform can be
found at Xalan Java 2.
- SAX 2.0
- SAX2 Extensions version 1.0
- DOM Level 2 Core Recommendation

%package manual
Summary: Manual for %{oldname}
Group: Development/Java

%description manual
Documentation for %{oldname}.

%package javadoc
Summary: Javadoc for %{oldname}
Group: Development/Documentation

%description javadoc
Javadoc for %{oldname}.

%package demo
Summary: Demo for %{oldname}
Group: Development/Java
Requires: %{name} = %{epoch}:%{version}-%{release}

%description demo
Demonstrations and samples for %{oldname}.

%prep
%setup -q -n %{oldname}-%{version}
%patch0 -p0

# -----------------------------------------------------------------------------

%build
CLASSPATH="$(find-jar xml-commons-apis)" ant jar javadoc

# -----------------------------------------------------------------------------

%install

# jars
%{__mkdir} -p ${RPM_BUILD_ROOT}%{_javadir}
%{__cp} -p build/%{oldname}.jar \
    ${RPM_BUILD_ROOT}%{_javadir}/%{oldname}-%{version}.jar
(
    cd $RPM_BUILD_ROOT%{_javadir}
    for jar in *-%{version}*; do 
        %{__ln_s} -f ${jar} `echo $jar | sed "s|-%{version}||g"`
    done
)

# javadoc
%{__mkdir} -p ${RPM_BUILD_ROOT}%{_javadocdir}/%{oldname}-%{version}
%{__cp} -pr build/docs/api/* \
    ${RPM_BUILD_ROOT}%{_javadocdir}/%{oldname}-%{version}
%{__ln_s} %{oldname}-%{version} \
    ${RPM_BUILD_ROOT}%{_javadocdir}/%{oldname} # ghost symlink

# demo
%{__mkdir} -p ${RPM_BUILD_ROOT}%{_datadir}/%{oldname}
%{__cp} -pr examples ${RPM_BUILD_ROOT}%{_datadir}/%{oldname}

# jaxp_parser_impl ghost symlink
%{__ln_s} %{_sysconfdir}/alternatives \
    ${RPM_BUILD_ROOT}%{_javadir}/jaxp_parser_impl.jar

%if %{gcj_support}
    export CLASSPATH="$(build-classpath gnu-crypto)"
    %{_bindir}/aot-compile-rpm
%endif
install -d $RPM_BUILD_ROOT/%_altdir; cat >$RPM_BUILD_ROOT/%_altdir/jaxp_parser_impl_%{oldname}<<EOF
%{_javadir}/jaxp_parser_impl.jar	%{_javadir}/%{oldname}.jar	20
EOF

%post
%register_alternatives jaxp_parser_impl_%{oldname}
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ "$1" -eq 0 ]; then
    %unregister_alternatives jaxp_parser_impl_%{oldname}
fi

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
fi
%endif

%post javadoc
%{__rm} -f %{_javadocdir}/%{oldname}
%{__ln_s} %{oldname}-%{version} %{_javadocdir}/%{oldname}

%postun javadoc
if [ "$1" -eq 0 ]; then
    %{__rm} -f %{_javadocdir}/%{oldname}
fi

%files
%_altdir/jaxp_parser_impl_%{oldname}
%doc ChangeLog README.txt
%{_javadir}/%{oldname}*.jar
#%ghost %{_javadir}/jaxp_parser_impl.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{oldname}
%{_libdir}/gcj/%{oldname}/%{oldname}-%{version}.jar.*
%endif

%files manual
%doc docs/*

%files javadoc
%{_javadocdir}/%{oldname}-%{version}
%ghost %{_javadocdir}/%{oldname}

%files demo
%{_datadir}/%{oldname}

%changelog
* Mon Oct 29 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.1.3-alt2_17jpp1.7
- fixed unmet in demo

* Tue Oct 23 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.1.3-alt1_17jpp1.7
- converted from JPackage by jppimport script

